<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="系统" prop="aircraftSystemId">
        <el-select v-model="queryParams.aircraftSystemId" placeholder="请选择" @change="handlesystemChange">
          <!--  -->
            <el-option
              v-for="item in allsystemOption"
              :key="item.id"
              :label="item.aircraft_type_name"
              :value="item.id">
            </el-option>
          </el-select>
      </el-form-item>


      <el-form-item label="分系统" prop="aircraftTypeName">
        <el-select v-model="queryParams.aircraftTypeName" placeholder="请选择">
            <el-option
              v-for="item in subSystemOption"
              :key="item.id"
              :label="item.aircraftTypeName"
              :value="item.aircraftTypeName">
            </el-option>
          </el-select>
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['system:subsystem:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['system:subsystem:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['system:subsystem:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['system:subsystem:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="subsystemList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="id" />
      <el-table-column label="系统" align="center" prop="aircraftSystemId" />
      <el-table-column label="分系统名称" align="center" prop="aircraftTypeName" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:subsystem:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['system:subsystem:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改分系统信息管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="系统" prop="aircraftSystemId">
        <el-select v-model="form.aircraftSystemId" placeholder="请选择">
            <el-option
              v-for="item in allsystemOption1"
              :key="item.id"
              :label="item.aircraft_type_name"
              :value="item.id">
            </el-option>
          </el-select>
      </el-form-item>

        <el-form-item label="分系统名称" prop="aircraftTypeName">
          <el-input v-model="form.aircraftTypeName" placeholder="请输入分系统名称" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listSubsystem, getSubsystem, delSubsystem, addSubsystem, updateSubsystem } from "@/api/system/subsystem";
import { getSysOption } from "@/api/system/system";
import { getSubSystemOption } from "@/api/system/subsystem"

export default {
  name: "Subsystem",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 分系统信息管理表格数据
      subsystemList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        aircraftSystemId: null,
        aircraftTypeName: null,
        aircraftSubsystemId:null
      },
      // 表单参数
      form: {
        aircraftSystemId: null,
        aircraftTypeName: null,
        remark:null,
      },
      // 表单校验
      rules: {
      },
      allsystemOption:[],
      allsystemOption1:[],
      subSystemOption:[],
      systemOption1:[],
    };
  },
  created() {
    this.getList();
    this.getSystemOption();
    this.getSystemOption1();
  },
  activated() {
    this.getSystemOption();
    this.getSystemOption1();
  },
  methods: {
    getSystemOption() {
      getSysOption().then(resp => {
        this.allsystemOption = resp.data
      })
    },
    getSystemOption1() {
      getSysOption().then(resp => {
        this.allsystemOption1 = resp.data
      })
    },
     //系统变化后更新分系统
     handlesystemChange(){
       this.queryParams.aircraftSubsystemId = '';
      getSubSystemOption(this.queryParams.aircraftSystemId).then(resp =>{
        this.subSystemOption = resp.data;
      })
    },
    /** 查询分系统信息管理列表 */
    getList() {
      this.loading = true;
      listSubsystem(this.queryParams).then(response => {
        this.subsystemList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        aircraftSystemId: null,
        aircraftTypeName: null,
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加分系统信息管理";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getSubsystem(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改分系统信息管理";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateSubsystem(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSubsystem(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.queryParams.aircraftSystemId= null;
              this.queryParams.aircraftTypeName= null;
              this.queryParams.aircraftSubsystemId=null;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除分系统信息管理编号为"' + ids + '"的数据项？').then(function() {
        return delSubsystem(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/subsystem/export', {
        ...this.queryParams
      }, `subsystem_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
